function  MountainCarDemo( maxepisodes )
%MountainCarDemo, the main function of the demo
%maxepisodes: maximum number of episodes to run the demo


clc
clf
rand('seed',1)

set(gco,'BackingStore','off')
maxsteps    = 1000;  % maximum number of steps per episode
statelist   = BuildStateList();  % the list of states
actionlist  = BuildActionList(); % the list of actions

nstates     = size(statelist,1);
nactions    = size(actionlist,1);
Q           = BuildQTable( nstates,nactions );  % the QTable
trace       = BuildQTable( nstates,nactions );  % the elegibility trace

alpha       = 1.5;   % learning rate
gamma       = 0.99;   % discount factor
lambda      = 0.95;   % the decaying elegibiliy trace parameter
epsilon     = 0.002;  % probability of a random action selection
epsilon_decay = 0.99;
grafica     = false;%true; % indicates if display the graphical interface
k           =4;
tau=2.5;  %O.P. temperature
tau_decay = 0.995; %O.P. decay
xpoints=[];
ypoints=[];

for i=1:maxepisodes    
    
    [total_reward,steps,Q,trace ] = Episode( maxsteps, Q, trace , alpha, gamma, epsilon, lambda, statelist, actionlist, k ,grafica, tau );    
    trace(:,:)=0.0;
%     disp(['Espisode: ',int2str(i),' steps: ',int2str(steps),' reward: ',num2str(total_reward),' epsilon: ',num2str(epsilon)])
    disp(['Espisode: ',int2str(i),' steps: ',int2str(steps),' reward: ',num2str(total_reward),' temperature: ',num2str(tau)])
    epsilon = epsilon * epsilon_decay;
    tau = tau * tau_decay;
    xpoints(i)=i-1;
    ypoints(i)=steps;
    subplot(2,1,1);    
    plot(xpoints,ypoints)      
    title(['Episode: ',int2str(i),' epsilon: ',num2str(epsilon)])    
    drawnow
    
    if (i==1)
        grafica=true;
    end
end





